net.sf.cpsolver.coursett.constraint

## Class MinimizeNumberOfUsedRoomsConstraint

- java.lang.Object
- - net.sf.cpsolver.ifs.model.Constraint<Lecture,Placement>
  - - net.sf.cpsolver.coursett.constraint.MinimizeNumberOfUsedRoomsConstraint

- All Implemented Interfaces:
    Comparable<Constraint<Lecture,Placement>>, WeakeningConstraint<Lecture,Placement>

      public class MinimizeNumberOfUsedRoomsConstraint
      extends Constraint<Lecture,Placement>
      implements WeakeningConstraint<Lecture,Placement>

  Minimize number of used rooms within the set of classes.
  This constraint implements the following distribution/group constraint:
  MIN_ROOM_USE (Minimize Number Of Rooms Used)
  Minimize number of rooms used by the given set of classes.
  Version:
    CourseTT 1.2 (University Course Timetabling)
    Copyright (C) 2006 - 2010 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Field Summary

    - ### Fields inherited from class net.sf.cpsolver.ifs.model.Constraint

      `iAssignedVariables, iConstraintListeners, iId`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MinimizeNumberOfUsedRoomsConstraint(DataProperties config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assigned(long iteration, Placement placement)` Given value is to be assigned to its varable.
    `void` | `computeConflicts(Placement placement, Set<Placement> conflicts)` The only method which has to be implemented by any constraint.
    `int` | `estimateLimit()`
    `String` | `getName()` Constraint's name -- for printing purposes
    `int` | `getOverLimit(Placement placement)`
    `boolean` | `inConflict(Placement placeement)` Returns true if the given assignment is inconsistent with the existing assignments respecting this constraint.
    `boolean` | `isConsistent(Placement value1, Placement value2)` Returns true if the given assignments are consistent respecting this constraint.
    `boolean` | `isEnabled()`
    `boolean` | `isOverLimit(Placement placement)`
    `void` | `setEnabled(boolean enabled)`
    `String` | `toString()`
    `void` | `unassigned(long iteration, Placement placement)` Given value is unassigned from its variable.
    `void` | `weaken()` Weaken the constraint.
    `void` | `weaken(Placement value)` Weaken the constraint enough so that it can assign the given value.

    - ### Methods inherited from class net.sf.cpsolver.ifs.model.Constraint

      `addConstraintListener, addVariable, assignedVariables, compareTo, constraintListeners, countAssignedVariables, countVariables, equals, getDescription, getId, getModel, hashCode, isHard, removeConstraintListener, removeVariable, setModel, variables`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MinimizeNumberOfUsedRoomsConstraint

          public MinimizeNumberOfUsedRoomsConstraint(DataProperties config)

  - ### Method Detail

    - #### isOverLimit

          public boolean isOverLimit(Placement placement)

    - #### getOverLimit

          public int getOverLimit(Placement placement)

    - #### computeConflicts

          public void computeConflicts(Placement placement,
                                       Set<Placement> conflicts)

      Description copied from class: `Constraint`
      The only method which has to be implemented by any constraint. It returns the values which needs to be unassigned in order to make this constraint consistent with the given value if it is assigned to its variable. The computed list of conflicting values is added to the given set of conflicts.
      Specified by:
        `computeConflicts` in class `Constraint<Lecture,Placement>`
      Parameters:
        `placement` - value to be assigned to its varaible
        `conflicts` - resultant set of conflicting values

    - #### inConflict

          public boolean inConflict(Placement placeement)

      Description copied from class: `Constraint`
      Returns true if the given assignment is inconsistent with the existing assignments respecting this constraint. This method is used by MAC (see `MacPropagation`).
      Overrides:
        `inConflict` in class `Constraint<Lecture,Placement>`

    - #### isConsistent

          public boolean isConsistent(Placement value1,
                                      Placement value2)

      Description copied from class: `Constraint`
      Returns true if the given assignments are consistent respecting this constraint. This method is used by MAC (see `MacPropagation`).
      Overrides:
        `isConsistent` in class `Constraint<Lecture,Placement>`

    - #### assigned

          public void assigned(long iteration,
                               Placement placement)

      Description copied from class: `Constraint`
      Given value is to be assigned to its varable. In this method, the constraint should unassigns all varaibles which are in conflict with the given assignment because of this constraint.
      Overrides:
        `assigned` in class `Constraint<Lecture,Placement>`

    - #### unassigned

          public void unassigned(long iteration,
                                 Placement placement)

      Description copied from class: `Constraint`
      Given value is unassigned from its variable.
      Overrides:
        `unassigned` in class `Constraint<Lecture,Placement>`

    - #### weaken

          public void weaken()

      Description copied from interface: `WeakeningConstraint`
      Weaken the constraint. This method is called if the constraint participates in an unassigned of a variable.
      Specified by:
        `weaken` in interface `WeakeningConstraint<Lecture,Placement>`

    - #### getName

          public String getName()

      Description copied from class: `Constraint`
      Constraint's name -- for printing purposes
      Overrides:
        `getName` in class `Constraint<Lecture,Placement>`

    - #### estimateLimit

          public int estimateLimit()

    - #### setEnabled

          public void setEnabled(boolean enabled)

    - #### isEnabled

          public boolean isEnabled()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### weaken

          public void weaken(Placement value)

      Description copied from interface: `WeakeningConstraint`
      Weaken the constraint enough so that it can assign the given value.
      Specified by:
        `weaken` in interface `WeakeningConstraint<Lecture,Placement>`